"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var icon_1 = require("../icon");
var clsPrefix = 'next-alert';
var Alert = /** @class */ (function (_super) {
    __extends(Alert, _super);
    function Alert(props) {
        var _this = _super.call(this, props) || this;
        _this.handleClose = function (e) {
            _this.setState({
                closed: true
            });
            if (_this.props.onClose) {
                _this.props.onClose(e);
            }
        };
        _this.state = {
            closed: false
        };
        return _this;
    }
    Alert.prototype.render = function () {
        var _a;
        var closed = this.state.closed;
        var _b = this.props, message = _b.message, type = _b.type, description = _b.description, closable = _b.closable, closeText = _b.closeText, showIcon = _b.showIcon;
        if (closed) {
            return null;
        }
        var classes = classnames_1.default(clsPrefix, (_a = {},
            _a[clsPrefix + "-" + type] = type,
            _a[clsPrefix + "-with-icon"] = showIcon,
            _a[clsPrefix + "-with-description"] = description,
            _a));
        var icon = null;
        if (showIcon) {
            if (description) {
                switch (type) {
                    case 'success':
                        icon = 'checkmark-circle-outline';
                        break;
                    case 'info':
                        icon = 'information-circle-outline';
                        break;
                    case 'warning':
                        icon = 'warning';
                        break;
                    case 'error':
                        icon = 'close-circle-outline';
                        break;
                }
            }
            else {
                switch (type) {
                    case 'success':
                        icon = 'checkmark-circle';
                        break;
                    case 'info':
                        icon = 'information-circle';
                        break;
                    case 'warning':
                        icon = 'warning';
                        break;
                    case 'error':
                        icon = 'close-circle';
                        break;
                }
            }
        }
        return (React.createElement("div", { className: classes },
            icon ? React.createElement("span", { className: clsPrefix + '-icon' },
                React.createElement(icon_1.default, { type: icon })) : null,
            React.createElement("span", { className: clsPrefix + '-message' }, message),
            description ? (React.createElement("span", { className: clsPrefix + '-description' }, description)) : null,
            closable ? React.createElement("a", { className: clsPrefix + '-close', onClick: this.handleClose }, closeText ? closeText : React.createElement("span", { className: clsPrefix + '-close-icon' }, "\u00D7")) : null));
    };
    Alert.defaultProps = {
        type: 'warning'
    };
    return Alert;
}(React.Component));
exports.default = Alert;
