import * as React from 'react';
import ButtonContext from './ButtonContext';
import ButtonGroup from './ButtonGroup';
declare const ButtonTypes: string[];
export declare type ButtonType = (typeof ButtonTypes)[number];
export declare type ButtonSize = 'large' | 'default' | 'small';
declare const AppearanceTypes: string[];
export declare type AppearanceType = (typeof AppearanceTypes)[number];
declare const ButtonHtmlTypes: string[];
export declare type ButtonHtmlType = (typeof ButtonHtmlTypes)[number];
export interface ButtonProps {
    type?: ButtonType;
    htmlType?: ButtonHtmlType;
    size?: ButtonSize;
    appearance?: AppearanceType;
    icon?: string;
    loading?: boolean;
    disabled?: boolean;
    onClick?: React.MouseEventHandler<HTMLAnchorElement>;
    block?: boolean;
    circle?: boolean;
    children: React.ReactNode;
}
declare class Button extends React.Component<ButtonProps, {}> {
    static Group: typeof ButtonGroup;
    static defaultProps: {
        htmlType: string;
    };
    static contextType: React.Context<import("./ButtonContext").ButtonContextProps>;
    context: React.ContextType<typeof ButtonContext>;
    handleClick: React.MouseEventHandler<HTMLButtonElement | HTMLAnchorElement>;
    renderIcon: () => JSX.Element | null;
    render(): React.ReactNode;
}
export default Button;
