"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var icon_1 = require("../icon");
var ButtonContext_1 = require("./ButtonContext");
var Loading_1 = require("./Loading");
var ButtonTypes = ['default', 'primary', 'danger'];
var AppearanceTypes = ['outline', 'dashed'];
var ButtonHtmlTypes = ['submit', 'reset', 'button'];
var buttonChildren = function (child) {
    if (child === undefined || child === null) {
        return null;
    }
    if (typeof child === 'string') {
        return React.createElement("span", null, child);
    }
    return child;
};
var classPrefix = "next-btn";
var Button = /** @class */ (function (_super) {
    __extends(Button, _super);
    function Button() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function (e) {
            var _a = _this.props, onClick = _a.onClick, loading = _a.loading, disabled = _a.disabled;
            if (loading || disabled) {
                return;
            }
            if (onClick) {
                onClick(e);
            }
        };
        _this.renderIcon = function () {
            var _a = _this.props, loading = _a.loading, icon = _a.icon;
            if ('loading' === icon || loading) {
                return React.createElement("span", { className: classPrefix + '-spin' },
                    React.createElement(Loading_1.default, null));
            }
            else if (icon) {
                return React.createElement(icon_1.default, { type: icon });
            }
            return null;
        };
        return _this;
    }
    Button.prototype.render = function () {
        var _a;
        var _b = this.props, children = _b.children, type = _b.type, size = _b.size, appearance = _b.appearance, loading = _b.loading, disabled = _b.disabled, htmlType = _b.htmlType, block = _b.block, circle = _b.circle;
        var _c = this.context.buttonGroup, buttonGroup = _c === void 0 ? {} : _c;
        var groupSize = buttonGroup.size;
        var classes = classnames_1.default((_a = {},
            _a[classPrefix] = true,
            _a[classPrefix + "-" + type] = type,
            _a[classPrefix + "-" + appearance] = appearance,
            _a[classPrefix + "-circle"] = circle,
            _a[classPrefix + "-" + (groupSize || size)] = groupSize || size,
            _a[classPrefix + "-loading"] = loading,
            _a[classPrefix + "-disabled"] = disabled,
            _a[classPrefix + "-block"] = block,
            _a));
        var iconNode = this.renderIcon();
        var kids = React.Children.map(children, buttonChildren);
        return (React.createElement("button", { type: htmlType, className: classes, onClick: this.handleClick },
            iconNode,
            kids));
    };
    Button.defaultProps = {
        htmlType: 'button'
    };
    Button.contextType = ButtonContext_1.default;
    return Button;
}(React.Component));
exports.default = Button;
