"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var CheckboxContext_1 = require("./CheckboxContext");
var classPrefix = 'next-checkbox';
var Checkbox = /** @class */ (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (e) {
            var disabled = _this.props.disabled;
            var onChange = _this.props.onChange;
            var checkboxGroup = _this.context.checkboxGroup;
            if (checkboxGroup) {
                if (checkboxGroup.disabled) {
                    disabled = checkboxGroup.disabled;
                }
                onChange = checkboxGroup.onChange;
            }
            if (disabled) {
                return;
            }
            var checked;
            if (!('checked' in _this.props)) {
                checked = e.target.checked;
            }
            else {
                checked = _this.props.checked;
                if (checkboxGroup) {
                    checked = checkboxGroup.value.indexOf(_this.props.value) !== -1;
                }
            }
            e.target.value = _this.props.value || '';
            _this.setState({
                checked: checked
            });
            if (onChange) {
                onChange(e);
            }
        };
        var checked = 'checked' in props ? props.checked : props.defaultChecked;
        _this.state = {
            checked: checked
        };
        return _this;
    }
    Checkbox.prototype.render = function () {
        var _a;
        var checkboxGroup = this.context.checkboxGroup;
        var children = this.props.children;
        var props = {
            className: classPrefix + '-input',
            checked: this.state.checked,
            onChange: this.handleChange,
            disabled: this.props.disabled
        };
        var checked = this.state.checked;
        if (checkboxGroup) {
            checked = checkboxGroup.value.indexOf(this.props.value) !== -1;
            props.disabled = this.props.disabled || checkboxGroup.disabled;
            props.checked = checked;
        }
        var classes = classnames_1.default(classPrefix, (_a = {},
            _a[classPrefix + "-checked"] = props.checked,
            _a[classPrefix + "-disabled"] = props.disabled,
            _a));
        if (!('checked' in this.props || checkboxGroup)) {
            delete props.checked;
        }
        return (React.createElement("label", { className: classPrefix + '-wrapper' },
            React.createElement("span", { className: classes },
                React.createElement("input", __assign({ type: 'checkbox' }, props)),
                React.createElement("span", { className: classPrefix + '-inner' })),
            children !== undefined ? React.createElement("span", null, children) : null));
    };
    Checkbox.contextType = CheckboxContext_1.default;
    return Checkbox;
}(React.Component));
exports.default = Checkbox;
