"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var Checkbox_1 = require("./Checkbox");
var CheckboxContext_1 = require("./CheckboxContext");
var classPrefix = 'next-checkbox-group';
var CheckboxGroup = /** @class */ (function (_super) {
    __extends(CheckboxGroup, _super);
    function CheckboxGroup(props) {
        var _this = _super.call(this, props) || this;
        _this.triggerChange = function (e) {
            var value = _this.state.value;
            var checkedValue = e.target.value;
            var index = value.indexOf(checkedValue);
            if (index === -1) {
                value.push(checkedValue);
            }
            else {
                value.splice(index, 1);
            }
            if (!('value' in _this.props)) {
                _this.setState({
                    value: value
                });
            }
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(value);
            }
        };
        var value = 'value' in props ? props.value : props.defaultValue;
        _this.state = {
            value: value || []
        };
        return _this;
    }
    CheckboxGroup.prototype.render = function () {
        var _this = this;
        var _a = this, state = _a.state, props = _a.props;
        var className = props.className, options = props.options, disabled = props.disabled;
        var children = props.children;
        if (options && options.length > 0) {
            children = options.map(function (option, index) {
                if (typeof option === 'string') {
                    return (React.createElement(Checkbox_1.default, { key: index, value: option, checked: state.value && state.value.indexOf(option) !== -1, onChange: _this.triggerChange, disabled: disabled }, option));
                }
                return (React.createElement(Checkbox_1.default, { key: index, value: option.value, checked: state.value && state.value.indexOf(option.value) !== -1, onChange: _this.triggerChange, disabled: disabled || option.disabled }, option.label));
            });
        }
        var classes = classnames_1.default(classPrefix, className);
        var context = {
            checkboxGroup: {
                value: this.state.value,
                disabled: this.props.disabled,
                onChange: this.triggerChange
            }
        };
        return (React.createElement(CheckboxContext_1.default.Provider, { value: context },
            React.createElement("div", { className: classes }, children)));
    };
    return CheckboxGroup;
}(React.Component));
exports.default = CheckboxGroup;
