"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var classPrefix = 'next-row';
var Row = /** @class */ (function (_super) {
    __extends(Row, _super);
    function Row() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Row.prototype.render = function () {
        var _a;
        var _b = this.props, children = _b.children, gutter = _b.gutter, style = _b.style;
        var classes = classnames_1.default((_a = {},
            _a[classPrefix] = true,
            _a));
        var rowStyle = gutter && gutter > 0 ? __assign({ marginLeft: gutter / -2, marginRight: gutter / -2 }, style) : style;
        var cols = React.Children.map(children, function (col) {
            if (!col) {
                return null;
            }
            if (col.props && (gutter && gutter > 0)) {
                return React.cloneElement(col, {
                    style: __assign({ paddingLeft: gutter / 2, paddingRight: gutter / 2 }, col.props.style)
                });
            }
            return col;
        });
        return (React.createElement("div", { className: classes, style: rowStyle }, cols));
    };
    return Row;
}(React.Component));
exports.default = Row;
