import * as React from 'react';
export declare type InputNumberSize = 'large' | 'default' | 'small';
export interface InputNumberProps {
    defaultValue?: number;
    value?: number;
    disabled?: boolean;
    min?: number;
    max?: number;
    step: number;
    size?: InputNumberSize;
    onChange?: (value: number | string) => {};
}
export interface InputNumberState {
    value?: string | number;
    focus?: boolean;
}
export default class InputNumber extends React.Component<InputNumberProps, InputNumberState> {
    constructor(props: InputNumberProps);
    static defaultProps: {
        disabled: boolean;
        step: number;
    };
    inputOnFocus: () => void;
    inputOnBlur: React.FocusEventHandler<HTMLInputElement>;
    inputOnChange: React.ChangeEventHandler<HTMLInputElement>;
    increase: () => void;
    decrease: () => void;
    setValidateValue: (value: string | number) => void;
    render(): React.ReactElement<any> | string | number | {} | React.ReactNodeArray | React.ReactPortal | boolean | null | undefined;
}
