"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var icon_1 = require("../icon");
var clsPrefix = 'next-input-number';
var isFloat = function (value) { return /(^-?|^\+?|^\d?)\d*\.\d+$/.test(value + ''); };
function getDecimalLength(value) {
    if (isFloat(value)) {
        return value.toString().split('.')[1].length;
    }
    return 0;
}
function decimals() {
    var values = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        values[_i] = arguments[_i];
    }
    var lengths = values.map(getDecimalLength);
    return Math.max.apply(Math, lengths);
}
var InputNumber = /** @class */ (function (_super) {
    __extends(InputNumber, _super);
    function InputNumber(props) {
        var _this = _super.call(this, props) || this;
        _this.inputOnFocus = function () {
            _this.setState({
                focus: true
            });
        };
        _this.inputOnBlur = function () {
            _this.setState({
                focus: false,
            });
        };
        _this.inputOnChange = function (e) {
            var value = e.target.value;
            if (!/^-?(?:\d+)?(\.)?(\d+)*$/.test(value) && value !== '') {
                return;
            }
            _this.setValidateValue(value);
        };
        _this.increase = function () {
            var value = _this.state.value;
            var step = _this.props.step;
            var bit = decimals(Number(value), step);
            _this.setValidateValue((Number(value) + step).toFixed(bit));
        };
        _this.decrease = function () {
            var value = _this.state.value;
            var step = _this.props.step;
            var bit = decimals(Number(value), step);
            _this.setValidateValue((Number(value) - step).toFixed(bit));
        };
        _this.setValidateValue = function (value) {
            var _a = _this.props, max = _a.max, min = _a.min, onChange = _a.onChange;
            var validateValue = value;
            if ((max || max === 0) && Number(validateValue) > max) {
                validateValue = max;
            }
            if ((min || min === 0) && Number(validateValue) < min) {
                validateValue = min;
            }
            _this.setState({
                value: validateValue
            });
            if (onChange) {
                onChange(validateValue);
            }
        };
        var value = 'value' in props ? props.value : props.defaultValue;
        _this.state = {
            value: value ? value : '',
            focus: false
        };
        return _this;
    }
    InputNumber.prototype.render = function () {
        var _a, _b, _c;
        var _d = this.state, focus = _d.focus, value = _d.value;
        var _e = this.props, disabled = _e.disabled, size = _e.size;
        var inputNumberClasses = classnames_1.default((_a = {},
            _a["" + clsPrefix] = true,
            _a[clsPrefix + "-" + size] = size,
            _a[clsPrefix + "-disabled"] = disabled,
            _a[clsPrefix + "-focus"] = focus,
            _a));
        var handlerUpClasses = classnames_1.default((_b = {},
            _b[clsPrefix + "-handler"] = true,
            _b[clsPrefix + "-handler-up"] = true,
            _b));
        var handlerDownClasses = classnames_1.default((_c = {},
            _c[clsPrefix + "-handler"] = true,
            _c[clsPrefix + "-handler-down"] = true,
            _c));
        return (React.createElement("div", { className: inputNumberClasses },
            disabled ? null : (React.createElement("div", { className: clsPrefix + '-handler-wrap' },
                React.createElement("span", { className: handlerUpClasses, onClick: this.increase },
                    React.createElement(icon_1.default, { type: 'arrow-up' })),
                React.createElement("span", { className: handlerDownClasses, onClick: this.decrease },
                    React.createElement(icon_1.default, { type: 'arrow-down' })))),
            React.createElement("div", { className: clsPrefix + '-input-wrap' },
                React.createElement("input", { onFocus: this.inputOnFocus, onBlur: this.inputOnBlur, onChange: this.inputOnChange, value: value, disabled: disabled }))));
    };
    InputNumber.defaultProps = {
        disabled: false,
        step: 1
    };
    return InputNumber;
}(React.Component));
exports.default = InputNumber;
