import * as React from 'react';
import InputGroup from './InputGroup';
import InputContext from './InputContext';
import TextArea from './TextArea';
export declare type InputSize = 'large' | 'default' | 'small' | undefined;
export interface InputProps {
    value?: string;
    defaultValue?: string;
    placeholder?: string;
    disabled?: boolean;
    size?: InputSize;
    style?: any;
    prefix?: React.ReactNode | string;
    suffix?: React.ReactNode | string;
    onChange?: React.ChangeEventHandler<HTMLInputElement>;
    hasClear?: boolean;
}
interface InputState {
    value?: string;
}
declare class Input extends React.Component<InputProps, InputState> {
    static Group: typeof InputGroup;
    static TextArea: typeof TextArea;
    input: HTMLInputElement;
    static contextType: React.Context<import("./InputContext").InputContextProps>;
    context: React.ContextType<typeof InputContext>;
    constructor(props: InputProps);
    static getDerivedStateFromProps(props: InputProps): {
        value: string | undefined;
    } | null;
    changeValue: (value: string, e: React.ChangeEvent<HTMLInputElement> | React.MouseEvent<HTMLElement, MouseEvent>) => void;
    handleChange: React.ChangeEventHandler<HTMLInputElement>;
    handleReset: (e: React.MouseEvent<HTMLElement, MouseEvent>) => void;
    renderInput: () => JSX.Element;
    render(): React.ReactNode;
}
export default Input;
