"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var icon_1 = require("../icon");
var InputContext_1 = require("./InputContext");
var classPrefix = 'next-input';
function fixValue(value) {
    if (typeof value === 'undefined' || value === null) {
        return '';
    }
    return value;
}
var Input = /** @class */ (function (_super) {
    __extends(Input, _super);
    function Input(props) {
        var _this = _super.call(this, props) || this;
        _this.changeValue = function (value, e) {
            if (!('value' in _this.props)) {
                _this.setState({
                    value: value
                });
            }
            var onChange = _this.props.onChange;
            if (onChange) {
                var event_1 = e;
                if (e.type === 'click') {
                    event_1 = Object.create(e);
                    event_1.target = _this.input;
                    event_1.currentTarget = _this.input;
                    _this.input.value = '';
                    onChange(event_1);
                    return;
                }
                onChange(event_1);
            }
        };
        _this.handleChange = function (e) {
            var value = e.target.value;
            _this.changeValue(value, e);
        };
        _this.handleReset = function (e) {
            _this.changeValue('', e);
        };
        _this.renderInput = function () {
            var _a, _b;
            var _c = _this.props, size = _c.size, placeholder = _c.placeholder, style = _c.style, prefix = _c.prefix, suffix = _c.suffix, hasClear = _c.hasClear, disabled = _c.disabled;
            var value = _this.state.value;
            var inputGroup = _this.context.inputGroup;
            var prefixNode = prefix ? (React.createElement("span", { className: classPrefix + '-prefix' }, prefix)) : null;
            var suffixNode = suffix ? (React.createElement("span", { className: classPrefix + '-suffix' }, suffix)) : null;
            var clearNode = undefined;
            if (hasClear && value) {
                var clearClass = classnames_1.default((_a = {},
                    _a[classPrefix + "-suffix"] = true,
                    _a[classPrefix + "-suffix-clear"] = true,
                    _a));
                clearNode = React.createElement("span", { className: clearClass, onClick: _this.handleReset },
                    React.createElement(icon_1.default, { type: 'close-circle' }));
            }
            var inputSize = 'default';
            if (inputGroup && inputGroup.size) {
                inputSize = inputGroup.size;
            }
            else {
                inputSize = size;
            }
            var classes = classnames_1.default((_b = {},
                _b[classPrefix + "-wrap"] = true,
                _b[classPrefix + "-" + inputSize] = inputSize,
                _b[classPrefix + "-wrap-disabled"] = disabled,
                _b));
            return (React.createElement("div", { className: classes, style: style },
                prefixNode,
                React.createElement("input", { value: fixValue(value), type: "text", placeholder: placeholder, className: classPrefix, onChange: _this.handleChange, ref: function (node) { return _this.input = node; }, disabled: disabled }),
                suffixNode,
                clearNode));
        };
        var value = 'value' in props ? props.value : props.defaultValue;
        _this.state = {
            value: value
        };
        return _this;
    }
    Input.getDerivedStateFromProps = function (props) {
        if ('value' in props) {
            return {
                value: props.value
            };
        }
        return null;
    };
    Input.prototype.render = function () {
        return this.renderInput();
    };
    Input.contextType = InputContext_1.default;
    return Input;
}(React.Component));
exports.default = Input;
