"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var CloseableMessage = /** @class */ (function (_super) {
    __extends(CloseableMessage, _super);
    function CloseableMessage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.startCloseTimer = function () {
            _this.closeTimer = setTimeout(function () {
                _this.clearCloseTimer();
                _this.props.onClose && _this.props.onClose();
            }, _this.props.duration * 1000);
        };
        _this.clearCloseTimer = function () {
            if (_this.closeTimer) {
                clearTimeout(_this.closeTimer);
                _this.closeTimer = 0;
            }
        };
        return _this;
    }
    CloseableMessage.prototype.componentDidMount = function () {
        var duration = this.props.duration;
        if (duration > 0) {
            this.startCloseTimer();
        }
    };
    CloseableMessage.prototype.componentWillUnmount = function () {
        this.clearCloseTimer();
    };
    CloseableMessage.prototype.render = function () {
        var content = this.props.content;
        return (React.createElement("div", null, content));
    };
    CloseableMessage.defaultPropTypes = {
        duration: 1.5
    };
    return CloseableMessage;
}(React.Component));
exports.default = CloseableMessage;
