"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var makeChainedFunction_1 = require("../utils/makeChainedFunction");
var CloseableMessage_1 = require("./CloseableMessage");
var MessageBox = /** @class */ (function (_super) {
    __extends(MessageBox, _super);
    function MessageBox(props) {
        var _this = _super.call(this, props) || this;
        _this.addMessage = function (message) {
            message.key = message.key || ('message_key_' + new Date().getTime());
            var messages = _this.state.messages;
            _this.setState({
                messages: messages.concat(message)
            });
        };
        _this.removeMessage = function (key) {
            _this.setState(function (preState) {
                return {
                    messages: preState.messages.filter(function (message) {
                        return message.key !== key;
                    })
                };
            });
        };
        _this.state = {
            messages: []
        };
        return _this;
    }
    MessageBox.prototype.render = function () {
        var _this = this;
        var _a = this.props, clsPrefix = _a.clsPrefix, style = _a.style;
        var messages = this.state.messages;
        var messageBoxes = messages.map(function (message) {
            var onClose = makeChainedFunction_1.default(function () {
                _this.removeMessage(message.key);
            }, message.onClose);
            return (React.createElement("div", { key: message.key },
                React.createElement(CloseableMessage_1.default, { content: message.content, duration: message.duration, onClose: onClose })));
        });
        return (React.createElement("div", { className: clsPrefix, style: style }, messageBoxes));
    };
    return MessageBox;
}(React.Component));
MessageBox.newInstance = function (properties) {
    var props = properties || {};
    var div = document.createElement('div');
    document.body.appendChild(div);
    var instance = null;
    var ref = function (messageBox) {
        instance = {
            showMessage: function (messageProps) {
                messageBox.addMessage(messageProps);
            },
            removeMessage: function () {
            },
            destroy: function () {
            }
        };
    };
    ReactDOM.render(React.createElement(MessageBox, __assign({ ref: ref }, props)), div);
    return instance;
};
exports.default = MessageBox;
