"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var message_box_1 = require("../message-box");
var icon_1 = require("../icon");
var clsPrefix = 'next-message';
var messageBoxInstance;
function noop() {
}
function showMessageBox(message, duration, type, onClose) {
    if (duration === void 0) { duration = 3; }
    if (onClose === void 0) { onClose = noop; }
    var _a;
    var instance = getMessageBoxInstance();
    var contentClasses = classnames_1.default((_a = {},
        _a[clsPrefix + "-content"] = true,
        _a[clsPrefix + "-" + type] = type,
        _a));
    var iconType = {
        'success': 'checkmark-circle',
        'error': 'close-circle',
        'info': 'information-circle',
        'warning': 'warning',
        'loading': 'info',
    }[type];
    instance.showMessage({
        duration: duration,
        content: (React.createElement("div", { className: contentClasses },
            React.createElement(icon_1.default, { type: iconType }),
            React.createElement("span", null, message))),
        onClose: onClose
    });
}
function getMessageBoxInstance() {
    messageBoxInstance = messageBoxInstance || message_box_1.default.newInstance({
        clsPrefix: clsPrefix,
    });
    return messageBoxInstance;
}
exports.default = {
    info: function (message, duration, onClose) {
        showMessageBox(message, duration, 'info', onClose);
    },
    success: function (message, duration, onClose) {
        showMessageBox(message, duration, 'success', onClose);
    },
    error: function (message, duration, onClose) {
        showMessageBox(message, duration, 'error', onClose);
    },
    warning: function (message, duration, onClose) {
        showMessageBox(message, duration, 'warning', onClose);
    },
    loading: function (message, duration, onClose) {
        showMessageBox(message, duration, 'loading', onClose);
    },
};
