"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var Text_1 = require("./Text");
var Line_1 = require("./Line");
var Circle_1 = require("./Circle");
var clsPrefix = 'next-progress';
var Progress = /** @class */ (function (_super) {
    __extends(Progress, _super);
    function Progress() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Progress.prototype.render = function () {
        var _a, _b;
        var _c = this.props, type = _c.type, stripe = _c.stripe, background = _c.background, showInfo = _c.showInfo;
        var status = this.props.status;
        var percent = this.props.percent;
        if (percent > 100) {
            percent = 100;
        }
        if (percent < 0) {
            percent = 0;
        }
        if (percent === 100) {
            status = 'success';
        }
        var classes = classnames_1.default((_a = {},
            _a["" + clsPrefix] = true,
            _a[clsPrefix + "-" + type] = type,
            _a[clsPrefix + "-status-" + status] = status,
            _a));
        var wrapperClasses = classnames_1.default(clsPrefix + '-wrapper', (_b = {},
            _b[clsPrefix + "-wrapper-no-text"] = !showInfo,
            _b));
        return (React.createElement("div", { className: classes },
            React.createElement("div", { className: wrapperClasses },
                React.createElement("div", { className: clsPrefix + '-inner' }, type === 'line' ? (React.createElement(Line_1.default, { percent: percent, stripe: stripe || false, background: background || '' })) : (React.createElement(Circle_1.default, { percent: percent })))),
            showInfo ? React.createElement(Text_1.default, { status: status || null, type: type || null, percent: percent }) : null));
    };
    Progress.defaultProps = {
        type: 'line',
        percent: 0,
        showInfo: true
    };
    return Progress;
}(React.Component));
exports.default = Progress;
