"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var RadioContext_1 = require("./RadioContext");
var classPrefix = 'next-radio';
var Radio = /** @class */ (function (_super) {
    __extends(Radio, _super);
    function Radio(props) {
        var _this = _super.call(this, props) || this;
        _this.handleChange = function (e) {
            var disabled = _this.props.disabled;
            var onChange = _this.props.onChange;
            var radioGroup = _this.context.radioGroup;
            if (radioGroup) {
                if (radioGroup.disabled) {
                    disabled = radioGroup.disabled;
                }
                onChange = radioGroup.onChange;
            }
            if (disabled) {
                return;
            }
            var checked;
            if (!('checked' in _this.props || radioGroup)) {
                checked = e.target.checked;
            }
            else {
                checked = _this.props.checked;
                if (radioGroup) {
                    checked = _this.props.value === radioGroup.value;
                }
            }
            e.target.value = _this.props.value;
            _this.setState({
                checked: checked
            });
            if (onChange) {
                onChange(e);
            }
        };
        var checked = 'checked' in props ? !!props.checked : !!props.defaultChecked;
        _this.state = {
            checked: checked
        };
        return _this;
    }
    Radio.prototype.componentWillReceiveProps = function (nextProps) {
        if ('checked' in nextProps) {
            this.setState({
                checked: nextProps.checked
            });
        }
    };
    Radio.prototype.render = function () {
        var _a, _b;
        var radioGroup = this.context.radioGroup;
        var children = this.props.children;
        var props = {
            className: classPrefix + '-input',
            checked: this.state.checked,
            onChange: this.handleChange,
            disabled: this.props.disabled
        };
        var checked = this.state.checked;
        if (radioGroup) {
            checked = radioGroup.value === this.props.value;
            props.disabled = this.props.disabled || radioGroup.disabled;
            props.checked = checked;
        }
        var labelClasses = classnames_1.default((_a = {},
            _a[classPrefix + "-wrapper"] = true,
            _a[classPrefix + "-wrapper-checked"] = props.checked,
            _a[classPrefix + "-button-disabled"] = props.disabled,
            _a));
        var classes = classnames_1.default(classPrefix, (_b = {},
            _b[classPrefix + "-checked"] = props.checked,
            _b[classPrefix + "-disabled"] = props.disabled,
            _b));
        if (!('checked' in this.props || radioGroup)) {
            delete props.checked;
        }
        return (React.createElement("label", { className: labelClasses },
            React.createElement("span", { className: classes },
                React.createElement("input", __assign({ type: "radio" }, props)),
                React.createElement("span", { className: classPrefix + '-inner' })),
            children !== undefined ? React.createElement("span", null, children) : null));
    };
    Radio.contextType = RadioContext_1.default;
    return Radio;
}(React.Component));
exports.default = Radio;
