"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var RadioContext_1 = require("./RadioContext");
var Radio_1 = require("./Radio");
var classPrefix = 'next-radio-group';
var RadioGroup = /** @class */ (function (_super) {
    __extends(RadioGroup, _super);
    function RadioGroup(props) {
        var _this = _super.call(this, props) || this;
        _this.triggerChange = function (e) {
            var _a = _this, state = _a.state, props = _a.props;
            if (!('value' in props) && state.value !== e.target) {
                _this.setState({
                    value: e.target
                });
            }
            var onChange = _this.props.onChange;
            if (onChange) {
                onChange(e);
            }
        };
        var value = 'value' in props ? props.value : props.defaultValue;
        _this.state = {
            value: value
        };
        return _this;
    }
    RadioGroup.prototype.render = function () {
        var _this = this;
        var _a;
        var _b = this, state = _b.state, props = _b.props;
        var options = props.options, disabled = props.disabled, className = props.className, type = props.type, size = props.size;
        var children = props.children;
        if (options && options.length > 0) {
            children = options.map(function (option, index) {
                if (typeof option === 'string') {
                    return (React.createElement(Radio_1.default, { key: index, value: option, checked: state.value === option, disabled: disabled, onChange: _this.triggerChange }, option));
                }
                return (React.createElement(Radio_1.default, { key: index, value: option.value, checked: state.value === option.value, disabled: disabled || option.disabled, onChange: _this.triggerChange }, option.label));
            });
        }
        var classes = classnames_1.default((_a = {},
            _a[classPrefix] = true,
            _a[classPrefix + "-button"] = type,
            _a[classPrefix + "-" + size] = size,
            _a[className] = className,
            _a));
        var context = {
            radioGroup: {
                value: this.state.value,
                disabled: this.props.disabled,
                onChange: this.triggerChange
            }
        };
        return (React.createElement(RadioContext_1.default.Provider, { value: context },
            React.createElement("div", { className: classes }, children)));
    };
    return RadioGroup;
}(React.Component));
exports.default = RadioGroup;
