"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var icon_1 = require("../icon");
var RateItem_1 = require("./RateItem");
var clsPrefix = 'next-rate';
var Rate = /** @class */ (function (_super) {
    __extends(Rate, _super);
    function Rate(props) {
        var _this = _super.call(this, props) || this;
        _this.handleItemMouseEnter = function (index, value) {
            var disabled = _this.props.disabled;
            if (!disabled) {
                _this.setState({
                    hoveredItemCount: index + value
                });
            }
        };
        _this.handleItemClick = function (index, value) {
            var _a = _this.props, disabled = _a.disabled, onChange = _a.onChange;
            if (disabled) {
                return;
            }
            var rateValue = index + value;
            if (!('value' in _this.props)) {
                _this.setState({
                    value: rateValue
                });
            }
            if (onChange) {
                onChange(rateValue);
            }
        };
        _this.handleMouseLeave = function () {
            _this.setState({
                hoveredItemCount: 0
            });
        };
        var value = 'value' in props ? props.value : props.defaultValue;
        _this.state = {
            hoveredItemCount: 0,
            value: value
        };
        return _this;
    }
    Rate.getDerivedStateFromProps = function (props) {
        if ('value' in props) {
            return {
                value: props.value
            };
        }
        return null;
    };
    Rate.prototype.render = function () {
        var _a = this.props, character = _a.character, count = _a.count, allowHalf = _a.allowHalf;
        var _b = this.state, hoveredItemCount = _b.hoveredItemCount, _c = _b.value, value = _c === void 0 ? 0 : _c;
        var items = [];
        for (var i = 0; i < count; i++) {
            var itemHoverValue = hoveredItemCount - i;
            if (itemHoverValue > 0.5) {
                itemHoverValue = 1;
            }
            else if (itemHoverValue == 0.5) {
                itemHoverValue = 0.5;
            }
            else {
                itemHoverValue = 0;
            }
            var itemValue = value - i;
            if (itemValue > 0.5) {
                itemValue = 1;
            }
            else if (itemValue == 0.5) {
                itemValue = 0.5;
            }
            else {
                itemValue = 0;
            }
            //let itemHoverValue = i < hoveredItemCount ? 1 : 0;
            itemValue = hoveredItemCount == 0 && itemValue ? itemValue : 0;
            items.push(React.createElement(RateItem_1.default, { key: i, index: i, allowHalf: allowHalf, onClick: this.handleItemClick, onMouseEnter: this.handleItemMouseEnter, value: itemValue, hoverValue: itemHoverValue }, character));
        }
        return (React.createElement("div", { className: clsPrefix, onMouseLeave: this.handleMouseLeave }, items));
    };
    Rate.defaultProps = {
        count: 5,
        character: React.createElement(icon_1.default, { type: "star" }),
        allowHalf: false,
    };
    return Rate;
}(React.Component));
exports.default = Rate;
