"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var DomHelper = require("../utils/dom-helper");
var clsPrefix = 'next-rate-item';
var RateItem = /** @class */ (function (_super) {
    __extends(RateItem, _super);
    function RateItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleMouseMove = function (e) {
            e.preventDefault();
            var _a = _this.props, onMouseEnter = _a.onMouseEnter, index = _a.index;
            if (onMouseEnter) {
                var value = _this.getValue(e);
                onMouseEnter(index, value, e);
            }
        };
        _this.handleClick = function (e) {
            e.preventDefault();
            var value = _this.getValue(e);
            var _a = _this.props, onClick = _a.onClick, index = _a.index;
            onClick(index, value, e);
        };
        _this.getValue = function (e) {
            var value = 1;
            if (_this.props.allowHalf) {
                var rect = DomHelper.getBoundingClientRect(_this.itemRef);
                var pageX = e.pageX;
                if (rect) {
                    var nodeWidth = rect.width;
                    var nodeOffsetLeft = rect.left;
                    if (pageX - nodeOffsetLeft < nodeWidth / 2) {
                        value = value - 0.5;
                    }
                }
            }
            return value;
        };
        return _this;
    }
    RateItem.prototype.render = function () {
        var _this = this;
        var _a, _b;
        var _c = this.props, allowHalf = _c.allowHalf, children = _c.children, value = _c.value, hoverValue = _c.hoverValue, disabled = _c.disabled;
        var classes = classnames_1.default(clsPrefix, (_a = {},
            _a[clsPrefix + "-hover"] = hoverValue === 1,
            _a[clsPrefix + "-active"] = hoverValue === 0 && value === 1,
            _a[clsPrefix + "-disabled"] = disabled,
            _a));
        var halfClasses = classnames_1.default((_b = {},
            _b[clsPrefix + "-half"] = true,
            _b[clsPrefix + "-hover"] = hoverValue === 0.5,
            _b[clsPrefix + "-active"] = value === 0.5,
            _b));
        return (React.createElement("div", { className: classes, onMouseMove: this.handleMouseMove, onClick: this.handleClick, ref: function (node) { return _this.itemRef = node; } },
            allowHalf ? React.createElement("span", { className: halfClasses }, children) : null,
            children));
    };
    RateItem.defaultProps = {
        allowHalf: false,
        disabled: false,
    };
    return RateItem;
}(React.Component));
exports.default = RateItem;
