"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var utils_1 = require("./utils");
var tooltip_1 = require("../tooltip");
var Control = /** @class */ (function (_super) {
    __extends(Control, _super);
    function Control(props) {
        var _this = _super.call(this, props) || this;
        _this.handleMouseOver = function (e) {
            e.preventDefault();
            e.stopPropagation();
            _this.setState({
                sliding: true
            });
        };
        _this.handleMouseOut = function (e) {
            e.preventDefault();
            e.stopPropagation();
            _this.setState({
                sliding: false
            });
        };
        _this.handleMouseDown = function (e) {
            e.preventDefault();
            e.stopPropagation();
            _this.setState({
                sliding: true
            });
            _this.addDocumentEvents();
        };
        _this.handleMouseUp = function (e) {
            e.preventDefault();
            e.stopPropagation();
            _this.setState({
                visibles: {},
                sliding: false
            });
            _this.removeDocumentEvents();
        };
        _this.handelMouseMove = function (e) {
            var _a;
            var _b = _this.props, max = _b.max, min = _b.min, step = _b.step, slider = _b.slider, onChange = _b.onChange, disabled = _b.disabled, vertical = _b.vertical;
            e.preventDefault();
            e.stopPropagation();
            if (disabled) {
                return;
            }
            var sliderDOM = ReactDOM.findDOMNode(slider.refs['slider']);
            var value;
            if (vertical) {
                value = utils_1.calculateY(e, sliderDOM, max, min, step);
            }
            else {
                value = utils_1.calculateX(e, sliderDOM, max, min, step);
            }
            _this.setState({
                visibles: __assign({}, _this.state.visibles, (_a = {}, _a["" + value] = true, _a))
            });
            if (onChange) {
                onChange(value);
            }
        };
        _this.addDocumentEvents = function () {
            document.addEventListener("mousemove", _this.handelMouseMove);
            document.addEventListener("mouseup", _this.handleMouseUp);
        };
        _this.removeDocumentEvents = function () {
            document.removeEventListener("mousemove", _this.handelMouseMove);
            document.removeEventListener("mouseup", _this.handleMouseUp);
        };
        _this.state = {
            visibles: {},
            sliding: false
        };
        return _this;
    }
    Control.prototype.render = function () {
        var _a = this.props, clsPrefix = _a.clsPrefix, value = _a.value, max = _a.max, min = _a.min, vertical = _a.vertical;
        var _b = this.state, visibles = _b.visibles, sliding = _b.sliding;
        // @ts-ignore
        var ratio = Number(value / (max - min)).toFixed(2) * 100;
        var controlStyle;
        if (vertical) {
            controlStyle = {
                top: ratio + '%'
            };
        }
        else {
            controlStyle = {
                left: ratio + '%'
            };
        }
        return (React.createElement(tooltip_1.default, { title: value || min, visible: visibles[value] || sliding },
            React.createElement("div", { className: clsPrefix + '-control', style: controlStyle, onMouseOut: this.handleMouseOut, onMouseOver: this.handleMouseOver, onMouseDown: this.handleMouseDown, onMouseUp: this.handleMouseUp })));
    };
    return Control;
}(React.Component));
exports.default = Control;
