"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DOMHelper = require("../utils/dom-helper");
function calculateX(event, sliderDOM, max, min, step) {
    var sliderRect = DOMHelper.getOffsetRectRelativeToCustomParent(sliderDOM, document.body);
    if (sliderRect) {
        var width = sliderRect.width;
        var pointX = event.clientX;
        var offsetWidth = pointX - sliderRect.left;
        if (offsetWidth <= 0) {
            offsetWidth = 0;
        }
        if (offsetWidth >= width) {
            offsetWidth = width;
        }
        var precision = 2;
        var tmps = step.toString().split(".");
        if (tmps.length === 2) {
            precision = tmps[1].length;
        }
        var ratio = Number(offsetWidth / width);
        return Number(Number(Math.ceil(ratio * (max - min) / step) * step).toFixed(precision));
    }
    return 0;
}
exports.calculateX = calculateX;
function calculateY(event, sliderDOM, max, min, step) {
    var sliderRect = DOMHelper.getBoundingClientRect(sliderDOM);
    if (sliderRect) {
        var height = sliderRect.height;
        var pointY = event.clientY;
        var offsetHeight = pointY - sliderRect.top;
        if (offsetHeight <= 0) {
            offsetHeight = 0;
        }
        if (offsetHeight >= height) {
            offsetHeight = height;
        }
        var precision = 2;
        var tmps = step.toString().split(".");
        if (tmps.length === 2) {
            precision = tmps[1].length;
        }
        var ratio = Number(offsetHeight / height);
        return Number(Number(Math.ceil(ratio * (max - min) / step) * step).toFixed(precision));
    }
    return 0;
}
exports.calculateY = calculateY;
