"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var clsPrefix = 'next-switch';
var Switch = /** @class */ (function (_super) {
    __extends(Switch, _super);
    function Switch(props) {
        var _this = _super.call(this, props) || this;
        _this.handleClick = function (event) {
            event.preventDefault();
            var _a = _this.props, onChange = _a.onChange, disabled = _a.disabled;
            if (disabled) {
                return;
            }
            var checked;
            if (!('checked' in _this.props)) {
                checked = !_this.state.checked;
            }
            else {
                checked = !_this.props.checked;
            }
            _this.setState({
                checked: checked
            });
            if (onChange) {
                onChange(checked, event);
            }
        };
        var checked = 'checked' in props ? props.checked : props.defaultChecked;
        _this.state = {
            checked: checked
        };
        return _this;
    }
    Switch.getDerivedStateFromProps = function (props) {
        var disabled = props.disabled;
        if (!disabled && 'checked' in props) {
            return {
                checked: props.checked
            };
        }
        return null;
    };
    Switch.prototype.render = function () {
        var _a;
        var checked = this.state.checked;
        var _b = this.props, checkedChildren = _b.checkedChildren, uncheckedChildren = _b.uncheckedChildren, disabled = _b.disabled;
        var classes = classnames_1.default(clsPrefix, (_a = {},
            _a[clsPrefix + "-checked"] = checked,
            _a[clsPrefix + "-disabled"] = disabled,
            _a));
        return (React.createElement("span", { className: classes, onClick: this.handleClick },
            (checkedChildren || uncheckedChildren) ? checked ?
                React.createElement("span", { className: clsPrefix + '-text' }, checkedChildren)
                : React.createElement("span", { className: clsPrefix + '-text' }, uncheckedChildren) : null,
            React.createElement("span", { className: clsPrefix + '-inner' })));
    };
    return Switch;
}(React.Component));
exports.default = Switch;
