"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var clsPrefix = 'next-tag';
var innerColors = ['red', 'orange', 'yellow', 'olive', 'green',
    'teal', 'blue', 'violet', 'purple', 'pink', 'brown', 'grey', 'black'];
var Tag = /** @class */ (function (_super) {
    __extends(Tag, _super);
    function Tag() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Tag.prototype.render = function () {
        var _a;
        var _b = this.props, shape = _b.shape, color = _b.color, children = _b.children, style = _b.style;
        var isInnerColor = innerColors.includes(color || '');
        var classes = classnames_1.default(clsPrefix, (_a = {},
            _a[clsPrefix + "-" + shape] = shape,
            _a[clsPrefix + "-" + color] = isInnerColor,
            _a[clsPrefix + "-with-color"] = !isInnerColor && color,
            _a));
        var mergeStyle = isInnerColor ? style : __assign({}, style, { background: color });
        return (React.createElement("div", { className: classes, style: mergeStyle }, children ? React.createElement("span", { className: clsPrefix + '-text' }, children) : null));
    };
    return Tag;
}(React.Component));
exports.default = Tag;
