"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var moment_1 = require("moment");
var Select_1 = require("./Select");
var Combobox = /** @class */ (function (_super) {
    __extends(Combobox, _super);
    function Combobox(props) {
        var _this = _super.call(this, props) || this;
        _this.handleSelect = function (v, type) {
            var onChange = _this.props.onChange;
            var value = _this.state.value;
            if (onChange) {
                onChange(value.clone()[type](v));
            }
        };
        _this.state = {
            value: props.value || moment_1.default()
        };
        return _this;
    }
    Combobox.prototype.componentWillReceiveProps = function (nextProps) {
        var nextValue = nextProps.value;
        this.setState({
            value: nextValue
        });
    };
    Combobox.prototype.render = function () {
        var _this = this;
        var _a = this.props, clsPrefix = _a.clsPrefix, hourOptions = _a.hourOptions, minuteOptions = _a.minuteOptions, secondOptions = _a.secondOptions;
        var value = this.state.value;
        return (React.createElement("div", { className: clsPrefix + '-picker-panel-combobox' },
            React.createElement(Select_1.default, { clsPrefix: clsPrefix, selectedIndex: hourOptions.indexOf(value.hour()), options: hourOptions, onSelect: function (v) { return _this.handleSelect(v, 'hour'); } }),
            React.createElement(Select_1.default, { clsPrefix: clsPrefix, selectedIndex: minuteOptions.indexOf(value.minute()), options: minuteOptions, onSelect: function (v) { return _this.handleSelect(v, 'minute'); } }),
            React.createElement(Select_1.default, { clsPrefix: clsPrefix, selectedIndex: secondOptions.indexOf(value.second()), options: secondOptions, onSelect: function (v) { return _this.handleSelect(v, 'second'); } })));
    };
    return Combobox;
}(React.Component));
exports.default = Combobox;
