"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function (value, e) {
            e.stopPropagation();
            e.nativeEvent.stopImmediatePropagation();
            _this.props.onSelect && _this.props.onSelect(value);
        };
        _this.renderOptions = function () {
            var _a = _this.props, clsPrefix = _a.clsPrefix, selectedIndex = _a.selectedIndex, options = _a.options;
            return options ? options.map(function (item, i) {
                var classes = selectedIndex === i ? clsPrefix + '-picker-panel-select-option-selected' : '';
                var v = item < 10 ? '0' + item : item;
                return React.createElement("li", { key: i, className: classes, onClick: function (e) { return _this.handleClick(v, e); } }, v);
            }) : null;
        };
        return _this;
    }
    Select.prototype.componentDidMount = function () {
        this.scrollTop();
    };
    Select.prototype.componentDidUpdate = function () {
        this.scrollTop();
    };
    Select.prototype.scrollTop = function () {
        var selectedIndex = this.props.selectedIndex;
        var element = ReactDOM.findDOMNode(this);
        var list = ReactDOM.findDOMNode(this.list);
        if (list) {
            var selectOption = list.children[selectedIndex];
            element.scrollTop = selectOption && selectOption.offsetTop || 0;
        }
    };
    Select.prototype.shouldComponentUpdate = function (nextProps) {
        var selectedIndex = this.props.selectedIndex;
        var nextSelectedIndex = nextProps.selectedIndex;
        if (selectedIndex !== nextSelectedIndex) {
            return true;
        }
        return false;
    };
    Select.prototype.render = function () {
        var _this = this;
        var clsPrefix = this.props.clsPrefix;
        return (React.createElement("div", { className: clsPrefix + '-picker-panel-select' },
            React.createElement("ul", { ref: function (list) { return _this.list = list; } }, this.renderOptions())));
    };
    return Select;
}(React.Component));
exports.default = Select;
