"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var icon_1 = require("../icon");
var Combobox_1 = require("./Combobox");
var clsPrefix = 'next-time';
var generateOptions = function (length, step) {
    if (step === void 0) { step = 1; }
    var values = [];
    for (var i = 0; i < length; i += step) {
        values.push(i);
    }
    return values;
};
var TimePicker = /** @class */ (function (_super) {
    __extends(TimePicker, _super);
    function TimePicker(props) {
        var _this = _super.call(this, props) || this;
        _this.documentOnClick = function () {
            _this.setState({
                showPicker: false,
            });
            document.removeEventListener('click', _this.documentOnClick);
        };
        _this.handleInputClick = function () {
            var disabled = _this.props.disabled;
            if (disabled) {
                return false;
            }
            _this.setState({
                showPicker: true
            });
            document.addEventListener("click", _this.documentOnClick);
        };
        _this.handleComboboxChange = function (time) {
            var onChange = _this.props.onChange;
            _this.setState({
                value: time
            });
            onChange && onChange(time);
        };
        _this.getFormatValue = function () {
            var value = _this.state.value;
            var formatStr = 'HH:mm:ss';
            var formatValue = '';
            if (!!value) {
                formatValue = value.format(formatStr);
            }
            return formatValue;
        };
        var value = 'value' in props ? props.value : props.defaultValue || '';
        _this.state = {
            showPicker: false,
            value: value
        };
        return _this;
    }
    TimePicker.prototype.render = function () {
        var _a = this.props, placeholder = _a.placeholder, disabled = _a.disabled, hourStep = _a.hourStep, minuteStep = _a.minuteStep, secondStep = _a.secondStep;
        var _b = this.state, showPicker = _b.showPicker, value = _b.value;
        var hourOptions = generateOptions(24, hourStep);
        var minuteOptions = generateOptions(60, minuteStep);
        var secondOptions = generateOptions(60, secondStep);
        return (React.createElement("div", { className: clsPrefix },
            React.createElement("div", { className: clsPrefix + '-input-wrap' },
                React.createElement("input", { className: clsPrefix + '-input', readOnly: true, placeholder: placeholder, onClick: this.handleInputClick, value: this.getFormatValue(), disabled: disabled }),
                React.createElement("span", { className: clsPrefix + '-icon' },
                    React.createElement(icon_1.default, { type: 'time' }))),
            showPicker ? (React.createElement("div", { className: clsPrefix + '-picker' },
                React.createElement("div", { className: clsPrefix + '-picker-panel' },
                    React.createElement("div", { className: clsPrefix + '-picker-panel-input-wrap' },
                        React.createElement("input", { readOnly: true, value: this.getFormatValue(), placeholder: placeholder })),
                    React.createElement(Combobox_1.default, { clsPrefix: clsPrefix, value: value, hourOptions: hourOptions, minuteOptions: minuteOptions, secondOptions: secondOptions, onChange: this.handleComboboxChange })))) : null));
    };
    return TimePicker;
}(React.Component));
exports.default = TimePicker;
