"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var ReactDOM = require("react-dom");
var classnames_1 = require("classnames");
var DOMHelper = require("../utils/dom-helper");
var Popup = /** @class */ (function (_super) {
    __extends(Popup, _super);
    function Popup(props) {
        var _this = _super.call(this, props) || this;
        _this.getDOMNode = function () {
            return ReactDOM.findDOMNode(_this);
        };
        _this.computePosition = function () {
            var _a = _this.props, placement = _a.placement, target = _a.target;
            var popupElement = ReactDOM.findDOMNode(_this);
            var targetElement = ReactDOM.findDOMNode(target);
            if (targetElement != null) {
                var targetParent = DOMHelper.getOffetParent(targetElement);
                if (!DOMHelper.isFixed(targetParent)) {
                    targetParent = window.document.body;
                }
                var popupRect = DOMHelper.getOuterSizes(popupElement);
                var targetRect = DOMHelper.getOffsetRectRelativeToCustomParent(targetElement, targetParent, DOMHelper.isFixed(targetParent));
                if (targetRect != null) {
                    var left = 0, top_1 = 0;
                    if (placement === 'top') {
                        left = targetRect.left + (targetRect.width - popupRect.width) / 2;
                        top_1 = targetRect.top - popupRect.height;
                    }
                    if (placement === 'top-left') {
                        left = targetRect.left;
                        top_1 = targetRect.top - popupRect.height;
                    }
                    if (placement === 'top-right') {
                        left = targetRect.right - popupRect.width;
                        top_1 = targetRect.top - popupRect.height;
                    }
                    if (placement === 'bottom') {
                        left = targetRect.left + (targetRect.width - popupRect.width) / 2;
                        top_1 = targetRect.top + targetRect.height;
                    }
                    if (placement === 'bottom-left') {
                        left = targetRect.left;
                        top_1 = targetRect.top + targetRect.height;
                    }
                    if (placement === 'bottom-right') {
                        left = targetRect.right - popupRect.width;
                        top_1 = targetRect.top + targetRect.height;
                    }
                    if (placement === 'left') {
                        left = targetRect.left - popupRect.width;
                        top_1 = targetRect.top + (targetRect.height - popupRect.height) / 2;
                    }
                    if (placement === 'left-top') {
                        left = targetRect.left - popupRect.width;
                        top_1 = targetRect.top;
                    }
                    if (placement === 'left-bottom') {
                        left = targetRect.left - popupRect.width;
                        top_1 = targetRect.bottom - popupRect.height;
                    }
                    if (placement === 'right') {
                        left = targetRect.right;
                        top_1 = targetRect.top + (targetRect.height - popupRect.height) / 2;
                    }
                    if (placement === 'right-top') {
                        left = targetRect.right;
                        top_1 = targetRect.top;
                    }
                    if (placement === 'right-bottom') {
                        left = targetRect.right;
                        top_1 = targetRect.bottom - popupRect.height;
                    }
                    _this.setState({
                        left: left,
                        top: top_1
                    });
                }
            }
        };
        _this.state = {
            left: 0,
            top: 0
        };
        return _this;
    }
    Popup.prototype.componentDidMount = function () {
        this.computePosition();
    };
    Popup.prototype.componentWillReceiveProps = function () {
        this.computePosition();
    };
    Popup.prototype.render = function () {
        var _a;
        var _b = this.props, classPrefix = _b.classPrefix, visible = _b.visible, placement = _b.placement, style = _b.style, children = _b.children, onMouseLeave = _b.onMouseLeave, onMouseEnter = _b.onMouseEnter;
        var _c = this.state, left = _c.left, top = _c.top;
        var newStyle = __assign({}, style, { left: left, top: top });
        var classes = classnames_1.default(classPrefix, (_a = {},
            _a[classPrefix + "-placement-" + placement] = placement,
            _a[classPrefix + "-hidden"] = !visible,
            _a));
        return (React.createElement("div", { className: classes, style: newStyle, onMouseEnter: onMouseEnter, onMouseLeave: onMouseLeave },
            React.createElement("div", { className: classPrefix + '-content' },
                React.createElement("div", { className: classPrefix + '-arrow' }),
                React.createElement("div", { className: classPrefix + '-inner' }, children))));
    };
    Popup.defaultProps = {
        visible: false
    };
    return Popup;
}(React.Component));
exports.default = Popup;
