import * as React from 'react';
declare type PlacementType = 'top' | 'top-left' | 'top-right' | 'bottom' | 'bottom-left' | 'bottom-right' | 'left' | 'left-top' | 'left-bottom' | 'right' | 'right-top' | 'right-bottom';
export interface TooltipProps {
    title?: any;
    visible?: boolean;
    trigger?: 'hover' | 'focus' | 'click';
    delay?: number;
    delayShow?: number;
    delayHide?: number;
    placement?: PlacementType;
}
export interface TooltipState {
    popupVisible: boolean;
    offsetLeft: number;
    offsetTop: number;
}
declare class Tooltip extends React.Component<TooltipProps, TooltipState> {
    __delayTimer: any;
    __container: any;
    __popup: any;
    constructor(props: TooltipProps);
    static defaultProps: {
        placement: string;
        trigger: string;
        delay: number;
    };
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: TooltipProps): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    getContainer: () => HTMLDivElement;
    makePopup: (props: TooltipProps) => JSX.Element;
    onMouseEnter: (e: React.MouseEvent<Element, MouseEvent>) => void;
    onMouseLeave: (e: React.MouseEvent<Element, MouseEvent>) => void;
    handleClick: () => void;
    handleVisible: (visible: boolean) => void;
    setVisible: (visible: boolean) => void;
    clearDelayTimer: () => void;
    render(): React.ReactElement<any>;
}
export default Tooltip;
