"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var request_1 = require("./request");
var UploadList_1 = require("./UploadList");
var clsPrefix = 'next-upload';
function getUId(index) {
    if (index === void 0) { index = 0; }
    return "next-upload-" + +(new Date()) + "-" + index;
}
function getFileItem(file, files) {
    return files.filter(function (f) { return !!f && f.uid === file.uid; })[0];
}
var Upload = /** @class */ (function (_super) {
    __extends(Upload, _super);
    function Upload(props) {
        var _this = _super.call(this, props) || this;
        _this.handleClick = function () {
            _this.fileInput.click();
        };
        _this.handleBeforeUpload = function (file, files) {
            var beforeUpload = _this.props.beforeUpload;
            if (beforeUpload) {
                return beforeUpload(file, files);
            }
            return true;
        };
        _this.handleFileChange = function (e) {
            var files = e.target.files;
            _this.uploadFiles(files);
        };
        _this.uploadFiles = function (files) {
            var postFiles = Array.prototype.slice.call(files);
            postFiles.forEach(function (file, index) {
                file.uid = getUId(index);
                file.status = 'uploading';
                if (_this.handleBeforeUpload(file, postFiles)) {
                    setTimeout(function () { return _this.postFile(file); }, 0);
                }
            });
            _this.resetFileInput();
        };
        _this.postFile = function (file) {
            var _a = _this.props, action = _a.action, headers = _a.headers, data = _a.data;
            var uid = file.uid;
            _this.reqs[uid] = request_1.default({
                action: action,
                file: file.file,
                headers: headers,
                data: data,
                onProgress: function (percent) {
                    file.percent = percent;
                    _this.handleChange(file);
                },
                onSuccess: function () {
                    delete _this.reqs[uid];
                    file.percent = 100;
                    file.status = 'done';
                    _this.handleChange(file);
                },
                onError: function () {
                    delete _this.reqs[uid];
                    file.percent = 100;
                    file.status = 'error';
                    _this.handleChange(file);
                }
            });
            _this.handleChange(file);
        };
        _this.handleChange = function (file) {
            var onChange = _this.props.onChange;
            var fileList = _this.state.fileList.slice();
            var fileItem = getFileItem(file, fileList);
            if (!fileItem) {
                fileList.push(file);
            }
            if (!('fileList' in _this.props)) {
                _this.setState({
                    fileList: fileList
                });
            }
            if (onChange) {
                onChange({ file: file, fileList: fileList });
            }
        };
        _this.resetFileInput = function () {
            _this.setState({
                inputKey: getUId(Math.random())
            });
        };
        _this.handleRemoveFile = function (file) {
            _this.setState(function (_a) {
                var fileList = _a.fileList;
                return {
                    fileList: fileList.filter(function (f) {
                        return f.uid !== file.uid;
                    })
                };
            });
        };
        var fileList = props.fileList || props.defaultFileList || [];
        _this.state = {
            fileList: fileList,
            inputKey: getUId(Math.random())
        };
        return _this;
    }
    Upload.prototype.componentWillReceiveProps = function (nextProps) {
        if ('fileList' in nextProps) {
            this.setState({
                fileList: nextProps.fileList || [],
            });
        }
    };
    Upload.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, accept = _a.accept, multiple = _a.multiple, listType = _a.listType;
        var _b = this.state, fileList = _b.fileList, inputKey = _b.inputKey;
        return (React.createElement("div", { className: clsPrefix + '-wrapper' },
            React.createElement("div", { onClick: this.handleClick, className: clsPrefix },
                React.createElement("input", { key: inputKey, accept: accept, multiple: multiple, ref: function (node) { return _this.fileInput = node; }, type: 'file', style: { display: 'none' }, onChange: this.handleFileChange }),
                children),
            React.createElement(UploadList_1.default, { clsPrefix: clsPrefix, fileList: fileList, listType: listType, onRemove: this.handleRemoveFile })));
    };
    Upload.defaultProps = {
        name: 'file',
        multiple: false,
        listType: 'text'
    };
    return Upload;
}(React.Component));
exports.default = Upload;
