"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var classnames_1 = require("classnames");
var icon_1 = require("../icon");
var tooltip_1 = require("../tooltip");
var progress_1 = require("../progress");
var UploadList = /** @class */ (function (_super) {
    __extends(UploadList, _super);
    function UploadList() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleRemoveFile = function (file) {
            var onRemove = _this.props.onRemove;
            onRemove && onRemove(file);
        };
        _this.renderTextItem = function (file) {
            var clsPrefix = _this.props.clsPrefix;
            var iconType = file.status === 'uploading' ? 'loading' : 'attach';
            return (React.createElement("span", null,
                React.createElement(icon_1.default, { type: iconType, spin: file.status === 'uploading' }),
                React.createElement("span", { className: clsPrefix + '-file-list-item-name' }, file.name),
                React.createElement("span", { className: clsPrefix + '-file-list-item-remove', onClick: function () { return _this.handleRemoveFile(file); } },
                    React.createElement(icon_1.default, { type: 'close' }))));
        };
        _this.renderPictureItem = function (file) {
            var clsPrefix = _this.props.clsPrefix;
            return (React.createElement("span", null,
                React.createElement("a", { className: clsPrefix + '-file-list-item-thumbnail', href: file.url, target: '_blank' },
                    React.createElement("img", { src: file.thumbUrl || file.url })),
                React.createElement("span", { className: clsPrefix + '-file-list-item-name' }, file.name),
                React.createElement("span", { className: clsPrefix + '-file-list-item-remove', onClick: function () { return _this.handleRemoveFile(file); } },
                    React.createElement(icon_1.default, { type: 'close' }))));
        };
        return _this;
    }
    UploadList.prototype.render = function () {
        var _this = this;
        var _a;
        var _b = this.props, clsPrefix = _b.clsPrefix, fileList = _b.fileList, listType = _b.listType;
        var classes = classnames_1.default((_a = {},
            _a[clsPrefix + "-file-list"] = true,
            _a[clsPrefix + "-file-list-" + listType] = !!listType,
            _a));
        var fileItems = fileList.map(function (file) {
            var _a;
            var itemClasses = classnames_1.default(clsPrefix + '-file-list-item', (_a = {},
                _a[clsPrefix + "-file-list-item-error"] = file.status === 'error',
                _a));
            var fileItem = (React.createElement("div", { key: file.uid },
                React.createElement("div", { className: itemClasses }, listType === 'text' ? _this.renderTextItem(file) : listType === 'picture' ? _this.renderPictureItem(file)
                    : null),
                file.status !== 'uploading' ? null : (React.createElement("div", { className: clsPrefix + '-file-list-item-progress' },
                    React.createElement(progress_1.default, { percent: file.percent, showInfo: false, status: file.status === 'error' ? 'exception' : null })))));
            if (file.status === 'error') {
                fileItem = (React.createElement(tooltip_1.default, { key: file.uid, title: "\u4E0A\u4F20\u5931\u8D25" }, fileItem));
            }
            return fileItem;
        });
        return (React.createElement("div", { className: classes }, fileItems));
    };
    UploadList.defaultProps = {
        fileList: []
    };
    return UploadList;
}(React.Component));
exports.default = UploadList;
