"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getError(option, xhr) {
    var msg = "cannot post " + option.action + " " + xhr.status + "'";
    var err = new Error(msg);
    err.status = xhr.status;
    err.method = 'post';
    err.url = option.action;
    return err;
}
function getBody(xhr) {
    var text = xhr.responseText || xhr.response;
    if (!text) {
        return text;
    }
    try {
        return JSON.parse(text);
    }
    catch (e) {
        return text;
    }
}
function upload(option) {
    if (option === void 0) { option = {}; }
    var xhr = new XMLHttpRequest();
    var formData = new FormData();
    if (option.data) {
        Object.keys(option.data).map(function (key) {
            formData.append(key, option.data[key]);
        });
    }
    formData.append(option.filename, option.file);
    if (xhr.upload) {
        xhr.upload.onprogress = function (event) {
            if (event.lengthComputable) {
                var percentComplete = event.loaded / event.total * 100;
                option.onProgress(percentComplete);
            }
            else {
                option.onProgress(0);
            }
        };
    }
    xhr.onload = function () {
        if (xhr.status < 200 || xhr.status >= 300) {
            return option.onError(getError(option, xhr), getBody(xhr));
        }
        option.onSuccess(getBody(xhr), xhr);
    };
    xhr.onerror = function (event) {
        option.onError(event);
    };
    xhr.open('post', option.action, true);
    var headers = option.headers || {};
    for (var header in headers) {
        if (headers.hasOwnProperty(header) && headers[header] !== null) {
            xhr.setRequestHeader(header, headers[header]);
        }
    }
    xhr.send(formData);
}
exports.default = upload;
