export declare function getOffetParent(element: Element | Text): Node & ParentNode;
export declare function getBoundingClientRect(element?: HTMLElement | null): {
    left: number;
    top: number;
    right: number;
    bottom: number;
    width: number;
    height: number;
} | null;
/**
 * Check if the given element is fixed or is inside a fixed parent
 * @function
 * @ignore
 * @argument {Element} element
 * @argument {Element} customContainer
 * @returns {Boolean} answer to "isFixed?"
 */
export declare function isFixed(element: HTMLElement): boolean;
/**
 * Returns the scrolling parent of the given element
 * @function
 * @ignore
 * @argument {Element} element
 * @returns {Element} offset parent
 */
export declare function getScrollParent(element: HTMLElement | null): Element | null;
/**
 * Get CSS computed property of the given element
 * @function
 * @ignore
 * @argument {Eement} element
 * @argument {String} property
 */
export declare function getStyleComputedProperty(element: HTMLElement, property: any): string;
/**
 * Given an element and one of its parents, return the offset
 * @function
 * @ignore
 * @param {HTMLElement} element
 * @param {HTMLElement} parent
 * @param {boolean} isFixed
 * @return {Object} rect
 */
export declare function getOffsetRectRelativeToCustomParent(element: HTMLElement, parent: HTMLElement, isFixed?: boolean): {
    top: number;
    left: number;
    bottom: number;
    right: number;
    width: number;
    height: number;
} | null;
/**
 * Get the outer sizes of the given element (offset size + margins)
 * @function
 * @ignore
 * @argument {Element} element
 * @returns {Object} object containing width and height properties
 */
export declare function getOuterSizes(element: HTMLElement): any;
